Subject: bug#33885: 27.0.50; PUA character makes emacs crash

From: Eli Zaretskii <[email-masked]>
Date: Thu, 27 Dec 2018 13:33:36 +0200

On December 27, 2018 12:36:14 PM GMT+02:00, Eli Zaretskii <[email-masked]> wrote:
> On December 27, 2018 10:54:59 AM GMT+02:00, Werner LEMBERG
> <[email-masked]> wrote:
> > 
> > Loading the attached file `bug.el' (containing the single PUA
> > character U+E6A3) with
> > 
> >   emacs -Q bug.el
> > 
> > causes a crash:
> > 
> >   xdisp.c:28955:
> >     Emacs fatal error:
> >       assertion failed:
> >         it->ascent >= 0 && it->descent >= 0
> > 
> > I've also attached the output of `bt full'.
> 
> 
> Thanks.
> 
> Do you have some custom font setup, which is supposed to display this
> PUA character?  Because on my system, there's no font for this
> codepoint (as I'd expect), and therefore Emacs displays it as
> "glyphless" character, showing a box with the character's code in hex,
> and that avoids the assertion violation.
> 
> So please step through x_produce_glyphs when Emacs needs to produce a
> glyph for this character, and tell how you end up with both ascent and
> descent values zero.  It isn't supposed to happen with valid fonts.

Sorry, I meant these values should be non-negatve.  It seems like in your case, descent is -5?  How come?